#if !defined(__diabrapp_h)              // Sentry, use file only if it's not already included.
#define __diabrapp_h

/*  Project diabar
    
    Copyright  1995. All Rights Reserved.

    SUBSYSTEM:    diabar.exe Application
    FILE:         diabrapp.h
    AUTHOR:       Free to Anyone


    OVERVIEW
    ========
    Class definition for diabarApp (TApplication).      
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include <classlib\bags.h>

#include "dbrmdicl.h"

#include "diabrapp.rh"            // Definition of all resources.


// TFileDrop class Maintains information about a dropped file, its name, where it was dropped,
// and whether or not it was in the client area
class TFileDrop {
public:
    operator == (const TFileDrop& other) const {return this == &other;}

    char*   FileName;
    TPoint  Point;
    bool    InClientArea;

    TFileDrop (char*, TPoint&, bool, TModule*);
    ~TFileDrop ();

    const char* WhoAmI ();
private:
    //
    // hidden to prevent accidental copying or assignment
    //
    TFileDrop (const TFileDrop&);
    TFileDrop & operator = (const TFileDrop&);
};

typedef TIBagAsVector<TFileDrop> TFileList;
typedef TIBagAsVectorIterator<TFileDrop> TFileListIter;


//{{TApplication = diabarApp}}
class diabarApp : public TApplication {
private:
    void SetupSpeedBar (TDecoratedMDIFrame *frame);
    void AddFiles (TFileList* files);

public:
    diabarApp ();
    virtual ~diabarApp ();

    void CreateGadgets (TControlBar *cb, bool server = false);

    diabarMDIClient  *mdiClient;

    // Public data members used by the print menu commands and Paint routine in MDIChild.
    TPrinter        *Printer;                           // Printer support.
    int             Printing;                           // Printing in progress.

//{{diabarAppVIRTUAL_BEGIN}}
public:
    virtual void InitMainWindow ();
    virtual void InitInstance ();
//{{diabarAppVIRTUAL_END}}

//{{diabarAppRSP_TBL_BEGIN}}
protected:
    void EvNewView (TView& view);
    void EvCloseView (TView& view);
    void CmHelpAbout ();
    void EvDropFiles (TDropInfo drop);
    void EvWinIniChange (char far* section);
//{{diabarAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(diabarApp);
};    //{{diabarApp}}


#endif                                      // __diabrapp_h sentry.
